<?php
// Pgina amb funcions per tractar de controlar la possible manipulaci de la sessi.

// Inicia la sessi al sevidor PHP.
session_start();

// Parametritza la capalera de la pgina per evitar l's la memoria cau 
// de servidors intermediaris.
header("Expires: Tue, 01 Jul 2001 06:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

// Funci que genera les varibles bsiques de sessi
// agent del client (navegador)
// adrea IP del client
// ltima acci
function obre(){
  $_SESSION['userAgent'] = $_SERVER['HTTP_USER_AGENT'];
  $_SESSION['IPaddress'] = $_SERVER['REMOTE_ADDR'];
  $_SESSION['LastActivity'] = $_SERVER['REQUEST_TIME'];
}

// Funci que genera una clau nica "testimoni d'intercanvi".
function genCl(){
  $_SESSION['SKey'] = uniqid(mt_rand(), true);
}

// Funci que controla la no susceptibilitat de manipulaci de les variables bsiques
// de sessi.
function vi(){
  if(($_SESSION['userAgent'] != $_SERVER['HTTP_USER_AGENT'])||
    ($_SESSION['IPaddress'] != $_SERVER['REMOTE_ADDR'])||
    (($_SESSION['LastActivity']+300) < $_SERVER['REQUEST_TIME'])){ // Desprs de 5 minuts sense activitat
      tanca();                                                     // tanca sessi.
      exit("Sessi invalidada");
  }
}

// Funci elimina totes les variables de sessi, la destrueix i torna a crear.
function tanca(){
  session_unset();
  session_destroy();
  session_start();
  session_regenerate_id(true);
}
?>